<?php
/*
* $Id: ordQtPro.php
* $Loc: /includes/hooks/admin/orders/
*
* Name: QTPro
* Version: 7.4.14
* Release Date: 2024-10-28
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under Commercial License
*
* Comments:  Author: [Rainer Schmied @raiwa]
*  Author URI: [www.phoenixcartaddons.com]
*  License: Commercial License Rainer Schmied
*  License URI: https://www.phoenixcartaddons.com/license.php
* 
*  Copyright (c) 2024 Rainer Schmied
*  
*  Redistribution and use in source and binary forms, with or without
*  modification, are not permitted without specific prior written permission
*  from Rainer Schmied
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
*  SOFTWARE.
*  
* 
*/

class hook_admin_orders_ordQtPro {

  public $version = '7.4.0';

  function listen_preAction() {
    global $db;

    if ( isset($GLOBALS['action']) && 'deleteconfirm' === $GLOBALS['action'] && $_POST['restock'] == 'on') {

      $oID = (int)($_GET['oID']);
      $order_query = $db->query(sprintf(<<<'EOSQL'
SELECT products_id, products_quantity, products_stock_attributes
  FROM orders_products
  WHERE orders_id = %s
EOSQL
      , (int)$oID));

      while ( $order = $order_query->fetch_assoc() ) {
        $product_stock_adjust = 0;
        if (!empty($order['products_stock_attributes'])) {
          if ($order['products_stock_attributes'] != '$$DOWNLOAD$$') {
            $attributes_stock_query = $db->query(sprintf(<<<'EOSQL'
SELECT products_stock_quantity
  FROM products_stock
  WHERE products_stock_attributes = '%s'
    AND products_id = %s
EOSQL
          , $order['products_stock_attributes'], (int)$order['products_id']));

            if (mysqli_num_rows($attributes_stock_query) > 0) {
              $attributes_stock_values = $attributes_stock_query->fetch_assoc();
              $db->query(sprintf(<<<'EOSQL'
UPDATE products_stock
  SET products_stock_quantity = products_stock_quantity + %s
  WHERE products_stock_attributes = '%s'
    AND products_id = %s
EOSQL
        , (int)$order['products_quantity'], $db->escape(Text::prepare($order['products_stock_attributes'])), (int)$order['products_id']));

                $product_stock_adjust = min($order['products_quantity'],  $order['products_quantity']+$attributes_stock_values['products_stock_quantity']);
            } else {
                $db->query(sprintf(<<<'EOSQL'
INSERT INTO products_stock (products_id, products_stock_attributes, products_stock_quantity)
  VALUES ('%s', '%s', '%s')
EOSQL
        , (int)$order['products_id'], $db->escape(Text::prepare($order['products_stock_attributes'])), (int)$order['products_quantity']));

                $product_stock_adjust = $order['products_quantity'];
            }
          }
        } else {
            $product_stock_adjust = $order['products_quantity'];
        }
        $db->query(sprintf(<<<'EOSQL'
UPDATE products
  SET products_quantity = products_quantity + %s, products_ordered = products_ordered - " . (int)$order['products_quantity'] . "
  WHERE products_id = %s
EOSQL
        , $db->escape(Text::prepare($product_stock_adjust)), (int)$order['products_id']));

      }

      $_POST['restock'] = false;
    }
  }


}
