<?php
/*
* $Id: swQtPro.php
* $Loc: /includes/hooks/admin/siteWide/
*
* Name: QTPro
* Version: 7.4.14
* Release Date: 2024-10-28
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under Commercial License
*
* Comments:  Author: [Rainer Schmied @raiwa]
*  Author URI: [www.phoenixcartaddons.com]
*  License: Commercial License Rainer Schmied
*  License URI: https://www.phoenixcartaddons.com/license.php
* 
*  Copyright (c) 2024 Rainer Schmied
*  
*  Redistribution and use in source and binary forms, with or without
*  modification, are not permitted without specific prior written permission
*  from Rainer Schmied
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
*  SOFTWARE.
*  
* 
*/

class hook_admin_siteWide_swQtPro {

  public $version = '7.4.0';

  function __construct() {

    require('includes/functions/qtpro_functions.php');

  }

  function listen_injectSiteStart() {
    global $product_investigation, $products_attributes_filename, $Admin;

    if ( 'catalog.php' === Request::get_page() ) {

      if ( !defined('PI_QTPRO_OPTIONS_STATUS') && !defined('MODULE_CONTENT_PI_QTPRO_OPTIONS_STATUS') ) {
        $GLOBALS['messageStack']->add(QTPRO_OPTIONS_WARNING . '<br>
              <a href="modules_content.php?module=cm_pi_qtpro_options&action=install">' . QTPRO_OPTIONS_INSTALL_NOW . '</a>', 'warning');
      }
      if (!file_exists(DIR_FS_CATALOG . 'templates/' . TEMPLATE_SELECTION . '/includes/hooks/shop/siteWide/qtPro.php')) {
        $GLOBALS['messageStack']->add(QTPRO_ERROR_SHOP_HOOK, 'warning');
      }

      //Create the product investigation for this product that are used in this page.
      $product_investigation = (isset($_GET['pID']))? qtpro_doctor_investigate_product($_GET['pID']) : null;
      $qtpro_sick_count = qtpro_sick_product_count();
      if ($qtpro_sick_count != 0) {
        $GLOBALS['messageStack']->add(sprintf(HOOK_SWQTPRO_WARNING, $qtpro_sick_count, $Admin->link('qtprodoctor.php')), 'error');
      }
    } elseif ( 'products_attributes.php' === Request::get_page() ) {

      $qtpro_sick_count = qtpro_sick_product_count();
      if ($qtpro_sick_count != 0) {
        $GLOBALS['messageStack']->add(sprintf(HOOK_SWQTPRO_WARNING, $qtpro_sick_count, $Admin->link('qtprodoctor.php')), 'error');
      }

      $products_attributes_filename = null;

    }

  }

}
