<?php
/*
* $Id: add_product.php
* $Loc: /includes/system/override/qtpro/actions/
*
* Name: QTPro
* Version: 7.4.14
* Release Date: 2024-10-28
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under Commercial License
*
* Comments:  Author: [Rainer Schmied @raiwa]
*  Author URI: [www.phoenixcartaddons.com]
*  License: Commercial License Rainer Schmied
*  License URI: https://www.phoenixcartaddons.com/license.php
* 
*  Copyright (c) 2024 Rainer Schmied
*  
*  Redistribution and use in source and binary forms, with or without
*  modification, are not permitted without specific prior written permission
*  from Rainer Schmied
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
*  SOFTWARE.
*  
* 
*/
	
  namespace Phoenix\Actions;

  class add_product {

    public static function execute() {
      if (isset($_POST['products_id'])) {
        $pid = (int)$_POST['products_id'];
//++++ QT Pro: Begin Changed code
        $attributes = [];
        if ( isset($_POST['attrcomb']) && (preg_match("/^\d{1,10}-\d{1,10}(,\d{1,10}-\d{1,10})*$/", $_POST['attrcomb'])) ) {
          $attrlist = explode(',', $_POST['attrcomb']);
          foreach ($attrlist as $attr) {
            list($oid, $oval) = explode('-',$attr);
            if ( is_numeric($oid) && $oid == (int)$oid && is_numeric($oval) && $oval==(int)$oval ) {
              $attributes[$oid] = $oval;
            }
          }
        }
        if ( isset($_POST['id']) && is_array($_POST['id']) ) {
          foreach ($_POST['id'] as $key => $val) {
            if (is_numeric($key) && $key == (int)$key && is_numeric($val) && $val==(int)$val ) {
              $attributes = $attributes + $_POST['id'];
            }
          }
        }
//++++ QT Pro: End Changed Code

        $qty = empty($_POST['qty']) ? 1 : (int)$_POST['qty'];

        $_SESSION['cart']->add_cart(
          $_POST['products_id'],
          $_SESSION['cart']->get_quantity(\Product::build_uprid($pid, $attributes))+$qty,
          $attributes);

        $GLOBALS['messageStack']->add_session(
          'product_action',
          sprintf(PRODUCT_ADDED, \Product::fetch_name($pid)),
          'success');
      }

      \Href::redirect(\Guarantor::ensure_global('Linker')
        ->build($GLOBALS['goto'])
        ->retain_query_except($GLOBALS['parameters']));
    }

  }
