<?php
/*
* $Id: pad_single_radioset.php
* $Loc: /includes/system/override/qtpro/
*
* Name: QTPro
* Version: 7.4.14
* Release Date: 2024-10-28
* Author: Rainer Schmied
* 	 phoenixcartaddonsaddons.com / raiwa@phoenixcartaddons.com
*
* License: Released under Commercial License
*
* Comments:  Author: [Rainer Schmied @raiwa]
*  Author URI: [www.phoenixcartaddons.com]
*  License: Commercial License Rainer Schmied
*  License URI: https://www.phoenixcartaddons.com/license.php
* 
*  Copyright (c) 2024 Rainer Schmied
*  
*  Redistribution and use in source and binary forms, with or without
*  modification, are not permitted without specific prior written permission
*  from Rainer Schmied
* 
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
*  SOFTWARE.
*  
* 
*/

  if (!class_exists('pad_single_radioset')) {
    class pad_single_radioset extends pad_single_dropdown {


  /*
      Method: _draw_stocked_attributes
      draw dropdown lists for attributes that stock is tracked for
      Parameters:
        none
      Returns:
        string:         HTML to display dropdown lists for attributes that stock is tracked for
  */
      function _draw_stocked_attributes() {

        $out= '' ;
        $combine_nostock = ($this->combine_non_stock == 'True')? true : false;
        $attributes = $this->_build_attributes_array(true, $combine_nostock);
        if (sizeof($attributes) > 0) {
          $combinations = [];
          $selected_combination = 0;
          $this->_build_attributes_combinations($attributes, $this->show_out_of_stock == 'True', $this->mark_out_of_stock, $combinations, $selected_combination);

          $combname = '';
          foreach ($attributes as $attrib) {
            $combname .= ', ' . $attrib['oname'];
          }
          $combname = substr($combname,2).': ';

          $out .= '<div class="table">' . PHP_EOL;
          $out .= ' <table class="table table-striped table-condensed table-hover">';
          $out .= '   <thead>' . PHP_EOL;
          $out .= '     <tr>' . PHP_EOL;
          $out .= '       <th>' . $combname . '</th>' . PHP_EOL;
          $out .= '     </tr>' . PHP_EOL;
          $out .= '   <thead>' . PHP_EOL;
          $out .= ' <tbody>' . PHP_EOL;

          foreach ($combinations as $combindex => $comb) {
            // BEGIN product optionsimages support
            if ($this->options_images) {
              if ( [] !== $comb['image'] ) {
                $images = null;
                for ($j=0, $k=sizeof($comb['image']); $j<$k; $j++) {
                  if ( !Text::is_empty($comb['image'][$j]) ) {
                    $images .= new Image('images/options/' . $comb['image'][$j], ['title' => $comb['text'], 'width' => '40', 'height' => '30']) . ' ';
                  }
                }
              }
              $comb['text'] = $images . $comb['text'];
            }
            // END product optionsimages support
            $out .= '   <tr class="table-selection">' . PHP_EOL;
            $out .= '     <td>' . (new Tickable('attrcomb', ['value' => $combinations[$combindex]['id']], 'radio'))->tick($combindex == $selected_combination) . ' ' . $comb['text'] . '</td>' . PHP_EOL;
            $out .= '   </tr>' . PHP_EOL;
          }
          $out .= '   </tbody>' . PHP_EOL;
          $out .= ' </table>' . PHP_EOL;
          $out .= '</div>' . PHP_EOL;
          $combname='';
        }
        return $out;
      }

    }
  }
